#!/bin/bash

#. cfg.env
. /usr/Adaptec_Event_Monitor/cfg.env
###############################################################################
###############               Function Declarations             ###############
###############################################################################
sendtestEmail()
{
    file=${EVENT_MONITOR_PATH}${CONFIG_FILE_SMTP}
	if [ -e $file ]
	then
 		echo "Send Test Email:"
        	echo "----------------"
        	fileContent=`grep -v EVENT_LISTENER_PORT $file | wc -l` 2> /dev/null
        	if [ $fileContent -gt '0' ]
        	then
        		echo -e "Enter recipient e-mail address: \c"
			read recipient

			server=$(grep -v EVENT_LISTENER_PORT $file 2> /dev/null|grep SMTP_SERVER)
			smtpServer=$(echo $server | awk -F = '{print $2}')

			port=$(grep -v EVENT_LISTENER_PORT $file 2> /dev/null|grep SMTP_PORT)
			smtpPort=$(echo $port | awk -F = '{print $2}')

			sender=$(grep -v EVENT_LISTENER_PORT $file 2> /dev/null|grep FROM_MAIL_ID)
 			fromMail=$(echo $sender | awk -F = '{ print $2 }')

			use_secure_mail_server=$(echo $(grep -v EVENT_LISTENER_PORT $file 2> /dev/null|grep USE_SECURE_MAIL_SERVER) | awk -F = '{print $2}')

			sp=$smtpServer:$smtpPort
			smtpServerPort=$( echo "$sp" | tr -d ' ')

			newline=$'\n'

			if [ -z "$smtpServer" ]
			then
				echo "No SMTP server address present in the SMTP server details. ${newline}Test email could not be delivered. "
			elif [ -z "$smtpPort" ]
			then
				echo "No SMTP server port present in the SMTP server details. ${newline}Test email could not be delivered."
			elif [ -z "$fromMail" ]
			then
				echo "No from email address present in the SMTP server details. ${newline}Test email could not be delivered. "

			else
				if [[ $fromMail != *?"@"?* ]]
				then
					echo "Invalid from email address in the SMTP server details. "
				elif [[ $recipient != *?"@"?* ]]
                then
					echo "Enter a valid recipient email address."
				else
					if [ $use_secure_mail_server == 'yes' ]
					then
						# Read the SMTP user name and password from user because we do not want to decrypt the password here.
						echo "${newline}Secured mail server is being used. Please enter your username and password for sending the test email.${newline}${newline}"
						echo -ne "Enter Username: "
						read userName
						if [ -n $userName ]
						then
							echo -ne "Enter Password: "
							stty -echo
							read password
							stty echo
							echo ""

							output=$(${EVENT_MONITOR_PATH}/sendEmail -v -o tls=yes -f $fromMail -t $recipient -u "Test Event Notification" -m "This is a test email from Adaptec Event Monitor.${newline} ${newline}${newline}**[NOTE]: This is a test email from Adaptec Event Monitor.${newline}Please do not reply to this message " -s $smtpServerPort -xu userName -xp password)
							res=`echo $?`
						else
							echo "Not Entered Proper Username."
						fi
					else
						# Use of secure email is set to no
						output=$(${EVENT_MONITOR_PATH}/sendEmail -v -o tls=no -f $fromMail -t $recipient -u "Test Event Notification" -m "This is a test email from Adaptec Event Monitor.${newline} ${newline}${newline}**[NOTE]: This is a test email from Adaptec Event Monitor.${newline}Please do not reply to this message " -s $smtpServerPort)
						res=`echo $?`
					fi

	    			if [ $res = 0 ]
					then
						echo "Test email successfully delivered to $recipient."
					else
						echo "Test email could not be delivered to $recipient."
					fi
				fi

			fi
		else
            		echo "No SMTP server details present."
      		fi

	else
        	echo "No SMTP server details present."
	fi


}

getSMTPServerDetails()
{
    file=${EVENT_MONITOR_PATH}${CONFIG_FILE_SMTP}
    if [ -e $file ]
    then
        echo "SMTP Server Details: "
        echo "--------------------"
        fileContent=`grep -v EVENT_LISTENER_PORT $file | wc -l` 2> /dev/null
        if [ $fileContent -gt '0' ]
        then
            grep -v EVENT_LISTENER_PORT $file 2> /dev/null
        else
            echo "No SMTP Server Details present."
        fi
    else
        echo "No SMTP Server Details present."
    fi
}

#Get Arguments in the order: SMTP Server, Port, From mail id, use Secure Mail Server Flag, SMTP username and Password
#If use Secure mail server flag is 'no', No need to put username and password
setSMTPServerDetails()
{
    file=${EVENT_MONITOR_PATH}${CONFIG_FILE_SMTP}
    if [ $# -gt 0 ]
    then
        if [ $# -eq 4 -o $# -eq 6 ]
        then
            echo "SMTP_SERVER=$1" > $file
            echo "SMTP_PORT=$2" >> $file
	    if [ "$3" != "blank" ]
	    then
            	echo "FROM_MAIL_ID=$3" >> $file
	    else
		echo "FROM_MAIL_ID= " >> $file
	    fi
            echo "USE_SECURE_MAIL_SERVER=$4" >> $file
            if [ $4 == 'yes' ]
            then
                if [ $# -eq 6 ]
                then
                    setUserAccountDetails $5 $6
                else
                    echo "Error! Arguments mismatch."
                fi
            elif [ $4 == 'no' ]
            then
                userDtlsFile=${EVENT_MONITOR_PATH}${CONFIG_FILE_USER}
                if [ -e $userDtlsFile ]
                then
                    rm -f $userDtlsFile
                fi
            fi
        fi
    else
        echo -ne "Enter the SMTP Server Address: "
        read serverSMTP
        if [ -z $serverSMTP ]
        then
            echo "No input from User."
        else
            if [ -e $file ]
            then
                grep EVENT_LISTENER_PORT $file > _temp 2> /dev/null
                mv _temp $file
                echo "SMTP_SERVER=$serverSMTP" >> $file
            else
                echo "SMTP_SERVER=$serverSMTP" > $file
            fi
            echo -ne "Enter the SMTP Server Port: "
            read portSMTP
            echo "SMTP_PORT=$portSMTP" >> $file
            echo -ne "Enter From Email Address: "
            read email
            echo "FROM_MAIL_ID=$email" >> $file
            secureFlag='NotOk'
            echo -ne "Use secure mail server? (yes/no): "
            while [ $secureFlag != 'Ok' ]
            do
                read use_secure_mail_server
                if [ $use_secure_mail_server ]
                then
                    if [ $use_secure_mail_server == 'yes' -o $use_secure_mail_server == 'no' ]
                    then
                        echo "USE_SECURE_MAIL_SERVER=$use_secure_mail_server" >> $file
                        secureFlag='Ok'
                        if [ $use_secure_mail_server == 'yes' ]
                        then
                            setUserAccountDetails
                        elif [ $use_secure_mail_server == 'no' ]
                        then
                            userDtlsFile=${EVENT_MONITOR_PATH}${CONFIG_FILE_USER}
                            if [ -e $userDtlsFile ]
                            then
                                echo "Deleting SMTP user details config file." > /dev/tty
                                rm -f $userDtlsFile
                            fi
                        fi
                    else
                        echo -ne "Incorrect entry! Enter correct option (yes/no):"
                    fi
                else
                    echo -ne "Incorrect entry! Enter correct option (yes/no):"
                fi
            done
        fi
    fi
}

setUserAccountDetails()
{
    file=${EVENT_MONITOR_PATH}${CONFIG_FILE_USER}
    if [ $# -gt 0 ]
    then
        if [ $# -eq 2 ]
        then
            ${EVENT_MONITOR_PATH}/encrypt $1 $2 $file
        fi
    else
        echo -ne "Enter Username: "
        read user
        if [ -n $user ]
        then
            echo -ne "Enter Password: "
            stty -echo
            read password
            stty echo
            echo ""
            #Call a C program to encrypt username and password
            ${EVENT_MONITOR_PATH}/encrypt $user $password $file
        else
            echo "Not Entered Proper UserName."
        fi
    fi
}

setMailRecipientDetails()
{
    file=${EVENT_MONITOR_PATH}${CONFIG_FILE_RECIPIENTS}
    case $1 in
        -a) if [ $# -gt 1 ]
            then
                if [ $# -eq 3 ]
                then
                    if [ $3 == 'I' -o $3 == 'W' -o $3 == 'E' ]
                    then
                        if [ -s $file ]
                        then
                            echo "$2,$3" >> $file
                        else
                            echo "$2,$3" > $file
                        fi
                    else
                        echo "Erroneous input."
                    fi
                fi
            else
                echo ""
                echo -ne "Enter Recipient e-mail address: "
                read email
                if [ $email ]
                then
                    matchFound=0
                    if [ -e $file ]
                    then
                        matchFound=`grep -w $email $file | wc -l` 2> /dev/null
                    fi
                    if [ $matchFound == 0 ]
                    then
                        echo "Email Notification Type."
                        echo "------------------------"
                        echo "I: Error, Warning & Informational"
                        echo "W: Error & Warning"
                        echo "E: Error"
                        echo -ne "Enter Notification Type (I/W/E): "
                        secureFlag='NotOk'
                        while [ $secureFlag != 'Ok' ]
                        do
                            read subscription;
                            if [ $subscription ]
                            then
                                if [ $subscription = 'I' -o $subscription = 'W' -o $subscription = 'E' ]
                                then
                                    secureFlag='Ok'
                                else
                                    echo -ne "Please enter correct notification (I/W/E):"
                                fi
                            else
                                echo -ne "Please enter correct notification (I/W/E):"
                            fi
                        done
			echo "Do you want Support.zip to be attached with the mail? (y/n)"
                        read supportZipAttach
                        if [ $supportZipAttach = 'y' -o $supportZipAttach = 'Y' ]
                        then
				isSupportZipAttach='Yes'
			else
				isSupportZipAttach='No'
			fi
                        if [ -e $file ]
                        then
                            echo "$email,$subscription,$isSupportZipAttach" >> $file
                        else
                            echo "$email,$subscription,$isSupportZipAttach" > $file
                        fi
                    else
                        echo "Recipient details already exist."
                    fi
                else
                    echo "No input from User."
                fi
            fi;;
        -d) if [ -e $file ]
            then
                echo -ne "Enter recipient e-mail to be deleted: "
                read email
                if [ $email ]
                then
                    matchFound=`grep -w $email $file | wc -l` 2> /dev/null
                    if [ $matchFound -gt '0' ]
                    then
                        echo "Match Found: Deleting."
                        grep -v -w $email $file > _temp 2> /dev/null
                        mv _temp $file
                        if [ ! -s $file ]
                        then
                            #File Empty: Remove it."
                            echo "File is empty! Deleting it."
                            rm -f $file
                        fi
                    else
                        echo "No such recipient."
                    fi
                else
                    echo "No input from User."
                fi
            else
                echo "No Recipient details present."
            fi;;
        -u) if [ -e $file ]
            then
                echo -ne "Enter recipient e-mail to be updated: "
                read email
                if [ $email ]
                then
                    matchFound=`grep -w $email $file` 2> /dev/null
                    if [ $matchFound ]
                    then
                        echo "Match Found:"
                        echo "Current Entry: $matchFound"
                        echo -ne "Do you want to update? (y/n):"
                        read usrInp
                        if [  -n $userInp ]
                        then
                            if [ $usrInp = 'y' -o $usrInp = 'Y' ] 2> /dev/null
                            then
                                echo "Subscription Levels."
                                echo "--------------------"
                                echo "I: Error, Warning & Informational"
                                echo "W: Error & Warning"
                                echo "E: Error"
                                echo -ne "Enter New Subscription Level: ";
                                secureFlag='NotOk'
                                while [ $secureFlag != 'Ok' ]
                                do
                                    read subscription;
                                    if [ -n $subscription ]
                                    then
                                        if [ "$subscription" = "I" -o "$subscription" = "W" -o "$subscription" = "E" ]
                                        then
                                            secureFlag='Ok'
                                        else
                                            echo -ne "Please enter correct subscription (I/W/E):"
                                        fi
                                    else
                                        echo -ne "Please enter correct subscription (I/W/E):"
                                    fi
                                done
	                        echo "Do you want Support.zip to be attached with the mail? (y/n)"
        	                read supportZipAttach
                	        if [ $supportZipAttach = 'y' -o $supportZipAttach = 'Y' ]
                        	then
                                	isSupportZipAttach='Yes'
                        	else
                                	isSupportZipAttach='No'
                        	fi
 
                                grep -v $email $file > _temp 2> /dev/null
                                mv _temp $file
                                echo "$email,$subscription,$isSupportZipAttach" >> $file
                            elif [ $usrInp = 'n' -o $usrInp = 'N' ] 2> /dev/null
                            then
                                echo "Exiting without updating"
                            else
                                echo "Not a proper input! Exiting without updating."
                            fi
                        else
                            echo "Not a proper input! Exiting without updating."
                        fi
                    else
                        echo "No such recipient."
                    fi
                else
                    echo "No input from User."
                fi
            else
                echo "No Recipient details present."
            fi;;
    esac
}

getMailRecipientDetails()
{
    file=${EVENT_MONITOR_PATH}${CONFIG_FILE_RECIPIENTS}
    if [ -s $file ]
    then
        echo "Recipients Information."
        echo "----------------------"
        cat $file > /dev/tty
    else
        echo "No Mail-Recipients added yet."
    fi
}

# This functions enables or disables the Email Notification Feature
# To enable we create a file Email_Notification_Status.cfg in the installation directory and put a value of 1 in it
# To disable we will change the value in the file to 0
# User has to restart the Event Monitor Service to apply these changes
setEmailNotificationStatus()
{
	file=${EVENT_MONITOR_PATH}${EMAIL_NOTIFICATION_STATUS_FILE}

	# Delete the file and create a new one with either 0 or 1 value in it
	if [ -e $file ]
	then
	    rm -f $file
	fi

	case $1 in
	     -e) echo "1" > $file
		 echo "Successfully Enabled Email Notification in the Configuration File"
		 echo "Please restart the Event Monitor Service to apply these changes"
		 ;;
	     -d) echo "0" > $file
		 echo "Successfully Disabled Email Notification in the Configuration File"
		 echo "Please restart the Event Monitor Service to apply these changes"
		 ;;
	esac
}

###############################################################################
###############               Main Program                      ###############
###############################################################################
if [ $# -gt 0 ]
then
    # -S : Pass Server IP, port, username and from Mail Id
    # -R : Pass Mail id and Subscription Level
    case $1 in
        -S) if [ $# -eq 4 ]
            then
                setSMTPServerDetails $2 $3 $4 $5
            else
                setSMTPServerDetails $2 $3 $4 $5 $6 $7
            fi;;
        -R) setMailRecipientDetails -a $2 $3;;
        -h) echo "Help File is under construction.";;
        *)  echo "Error! Argument mismatch."; exit 1;;
    esac
else
    echo ""; echo ""
    echo "SMTP Server Configuration Utility"
    echo "---------------------------------"
    while true
    do
        echo ""
        echo "Choose any of the following options:"
        echo "-----------------------------------------------------------------------------"
        echo "1) Enable Email Notification                  2) Disable Email Notification"
	echo "3) Get SMTP Server Details                    4) Set SMTP Server Details"
	echo "5) Get Recipient Information                  6) Set Recipient Information"
        echo "7) Update Recipient Information               8) Delete Recipient Information"
        echo "9) Send Test Email                           10) Exit "
        echo "-----------------------------------------------------------------------------"

        echo ""
        echo -ne "\nEnter your choice: "
        read choice
        echo""
        case $choice in
	    1) setEmailNotificationStatus -e;;
	    2) setEmailNotificationStatus -d;;
	    3) getSMTPServerDetails;;
            4) setSMTPServerDetails;;
            5) getMailRecipientDetails;;
            6) setMailRecipientDetails -a;;
            7) setMailRecipientDetails -u;;
            8) setMailRecipientDetails -d;;
	    9) sendtestEmail ;;
            10) echo "If you have made any changes, please execute \"/usr/Adaptec_Event_Monitor/EventMonitorService restart\" to restart the service."
	       echo ""
	       exit;;
            *) echo "Enter choice from the list shown above."
        esac
    done
fi
